=== etc/requirements.txt ===
alabaster==0.7.12
Babel==2.6.0
certifi==2018.11.29
chardet==3.0.4
CommonMark==0.5.4
docutils==0.14
idna==2.8
imagesize==1.1.0
Jinja2==2.10
MarkupSafe==1.1.0
packaging==18.0
Pygments==2.3.0
pyparsing==2.3.0
pytz==2018.7
recommonmark==0.4.0
requests==2.21.0
six==1.12.0
snowballstemmer==1.2.1
Sphinx==1.8.2
sphinx-rtd-theme==0.4.2
sphinxcontrib-websupport==1.1.0
typing==3.6.6
urllib3==1.24.1
